﻿using System;
using System.Collections.Generic;
using System.Text;

namespace pl0
{
    /// <summary>
    /// Kompilator PL0
    /// </summary>
    class PL0Compiler
    {
	    private LexicalA lexicalA;
	    
	    private SymbolT symbol = new SymbolT();
	    
	    private CodeGen code = new CodeGen();
	    
	    private BugBox bug = new BugBox();

        private BegSys bs = new BegSys();

	    public SymbolT getSymbolTable() {
		    return symbol;
	    }

	    public CodeGen getCode() {
		    return code;
	    }

	    public BugBox getBugBox() {
		    return bug;
	    }

	    protected void error(int errorType) {
		    lexicalA.writeError(errorType);
		    bug.error(errorType);
	    }

	    /// <summary>
	    /// Zahajeni kompilace zdrojoveho textu
	    /// </summary>
	    /// <param name="path">Soubor obsahujici zdrojovy kod PL0</param>
	    public void compile(String path) /*throw IOException*/{
		    lexicalA = new LexicalA(path);
		    SetSym pom = new SetSym();
            pom = pom.or(bs.declBegSys);
            pom = pom.or(bs.statBegSys);
		    pom.set(SetSym.PERIOD);
		    Block block = new Block(0, 0, pom);
		    block.setBugBox(bug);
		    block.run(lexicalA, symbol, code);
		    if (lexicalA.getCurrentSymbol() != SetSym.PERIOD)
			    error(BugBox.DOT_REQ);
	    }
    }
}
