﻿using System;
using System.Collections.Generic;
using System.Text;


using System.IO;

namespace pl0
{
    /// <summary>
    /// Program prekladace a interpretu jazyka PL/0
    /// </summary>
    class MainClass
    {
        public static void Main(string[] args)
        {
            String fileName;

            if (args.Length == 1)
            {
                fileName = args[0];
            }
            else
            {
                try
                {
                    Console.Out.WriteLine("Prekladac a interpret jazyka PL/0\n\n");
                    Console.Out.WriteLine("Zadejte jmeno souboru: ");
                    fileName = Console.In.ReadLine();
                }
                catch (IOException e)
                {
                    Console.Out.WriteLine("Chyba pri nacitani jmena souboru!");
                    Console.Out.WriteLine(e.StackTrace);
                    return;
                }
            }
            
            try { 
			PL0Compiler comp = new PL0Compiler();
			comp.compile(fileName);
			if (comp.getBugBox().getErrorsCount() == 0) {
				PL0Interpret interpret =
				  new PL0Interpret(comp.getSymbolTable(), comp.getCode());
				interpret.run();
			}
			Console.Out.WriteLine("Pocet chyb v programu: " + comp.getBugBox().getErrorsCount());

		    } catch (IOException e) {
			    Console.Out.WriteLine("Chyba pri praci se soubory!");
			    Console.Out.WriteLine(e.StackTrace);
		    } catch (ErrorsException e) {
                Console.Out.WriteLine("Prilis mnoho chyb v programu!");
                Console.Out.WriteLine(e.StackTrace);
		    }

        }
    }
}
